mapperVersion$ = "Mapper 2.0"
'Version 1.0 released January, 2001
'Version 2.0 released June, 2001
'Open source code originally by David Drake
'Permission is granted to modify, redistribute, copy, or sell (good luck!) this code.
'All that I ask is that you give me a little credit in the final product.
'drake@apexmail.com

[setupVariables]
    loadbmp "bm1","NEW1.BMP"
    loadbmp "bm2","OPEN1.BMP"
    loadbmp "bm3","SAVE1.BMP"
    loadbmp "bm4","DELETE1.BMP"
    loadbmp "bm5","IMAGE1.BMP"
    loadbmp "bm6","MAP1.BMP"
    loadbmp "bm7","BRANCH1.BMP"
    loadbmp "bm8","CODE1.BMP"
    loadbmp "bm11","NEW2.BMP"
    loadbmp "bm12","OPEN2.BMP"
    loadbmp "bm13","SAVE2.BMP"
    loadbmp "bm14","DELETE2.BMP"
    loadbmp "bm15","IMAGE2.BMP"
    loadbmp "bm16","MAP2.BMP"
    loadbmp "bm17","BRANCH2.BMP"
    loadbmp "bm18","CODE2.BMP"
    loadbmp "bm21","NEW3.BMP"
    loadbmp "bm22","OPEN3.BMP"
    loadbmp "bm23","SAVE3.BMP"
    loadbmp "bm24","DELETE3.BMP"
    loadbmp "bm25","IMAGE3.BMP"
    loadbmp "bm26","MAP3.BMP"
    loadbmp "bm27","BRANCH3.BMP"
    loadbmp "bm28","CODE3.BMP"

    dim map(100,5) ' Contains created map: 1=xorig, 2=yorg, 3=width, 4=height
    dim branch$(100,3) ' Contains the branchlabel for the onclick and onmouseover for map
    dim bitmapFile$(100,2)
    dim colorType$(20)
    dim bitmap(100,5)
    mapCount = 0 ' Number of mapped regions

    colorType$(1) = "none"
    colorType$(2) = "black"
    colorType$(3) = "blue"
    colorType$(4) = "brown"
    colorType$(5) = "cyan"
    colorType$(6) = "darkblue"
    colorType$(7) = "darkcyan"
    colorType$(8) = "darkgray"
    colorType$(9) = "darkgreen"
    colorType$(10) = "darkpink"
    colorType$(11) = "darkred"
    colorType$(12) = "green"
    colorType$(13) = "lightgray"
    colorType$(14) = "palegray"
    colorType$(15) = "pink"
    colorType$(16) = "red"
    colorType$(17) = "white"
    colorType$(18) = "yellow"
    colorType$(19) = "buttonface"

    'Set up clickable map coordinates
    'Area 1
    toolbar.maps = 8
    dim clickable(100,4)

    rem Coordinates for area that branches to [newMapFile]
    clickable(1,1) = 1: rem X location
    clickable(1,2) = 0: rem Y location
    clickable(1,3) = 45: rem Width
    clickable(1,4) = 40: rem Height
    rem Coordinates for area that branches to [openMapFile]
    clickable(2,1) = 51: rem X location
    clickable(2,2) = 0: rem Y location
    clickable(2,3) = 45: rem Width
    clickable(2,4) = 40: rem Height
    rem Coordinates for area that branches to [saveMapFile]
    clickable(3,1) = 101: rem X location
    clickable(3,2) = 0: rem Y location
    clickable(3,3) = 45: rem Width
    clickable(3,4) = 40: rem Height
    rem Coordinates for area that branches to [deleteItems]
    clickable(4,1) = 151: rem X location
    clickable(4,2) = 0: rem Y location
    clickable(4,3) = 45: rem Width
    clickable(4,4) = 40: rem Height
    rem Coordinates for area that branches to [openImage]
    clickable(5,1) = 201: rem X location
    clickable(5,2) = 0: rem Y location
    clickable(5,3) = 45: rem Width
    clickable(5,4) = 40: rem Height
    rem Coordinates for area that branches to [newMap]
    clickable(6,1) = 251: rem X location
    clickable(6,2) = 0: rem Y location
    clickable(6,3) = 45: rem Width
    clickable(6,4) = 40: rem Height
    rem Coordinates for area that branches to [showhideBranchlabels]
    clickable(7,1) = 301: rem X location
    clickable(7,2) = 0: rem Y location
    clickable(7,3) = 45: rem Width
    clickable(7,4) = 40: rem Height
    rem Coordinates for area that branches to [produceCode]
    clickable(8,1) = 351: rem X location
    clickable(8,2) = 0: rem Y location
    clickable(8,3) = 45: rem Width
    clickable(8,4) = 40: rem Height

    'other variables
    dim info$(10,10)
    createMap = 0
    showhideBranchlabels = 1

[openMainWindow]
    nomainwin
    WindowWidth = DisplayWidth
    WindowHeight = DisplayHeight - 30
    UpperLeftX = 1
    UpperLeftY = 1

    menu #main, "&File","&New",[newMapFile],"&Open Map File",[openMapFile],"&Save Map File",[saveMapFile],|,"&Add Bitmap",[openImage],|,"E&xit",[quit]
    menu #main, "&Maps","&New Map",[newMap],"&Delete Object",[deleteItems],"&Window Fill Color",[windowFillColor]
    menu #main, "&Produce Code","&Produce Code",[produceCode]
    menu #main, "&Options","&Show/Hide Branchlabels",[showhideBranchlabels]
    menu #main, "&Help","&About",[aboutMapper]
    graphicbox #main.toolbar, 0, 0, DisplayWidth-2, 50
    graphicbox #main.map, 0, 50, DisplayWidth-2, DisplayHeight - 80

    open mapperVersion$ for graphics_nsb as #main

    print #main.toolbar, "fill white"
    print #main.toolbar, "drawbmp bm1 0 0;"
    print #main.toolbar, "drawbmp bm2 50 0;"
    print #main.toolbar, "drawbmp bm3 100 0;"
    print #main.toolbar, "drawbmp bm4 150 0;"
    print #main.toolbar, "drawbmp bm5 200 0;"
    print #main.toolbar, "drawbmp bm6 250 0;"
    print #main.toolbar, "drawbmp bm7 300 0;"
    print #main.toolbar, "drawbmp bm8 350 0;"
    print #main.toolbar, "flush;"
    print #main, "trapclose [quit]"
    print #main.toolbar, "when leftButtonUp [leftButtonClicked]"
    print #main.map, "when leftButtonDown [leftButtonClickedMap]"
    print #main.map, "when rightButtonUp [rightButtonClickedMap]"
    print #main.map, "when leftButtonDouble [leftButtonDoubleClickedMap]"
    print #main.toolbar, "when mouseMove [mouseMoved]"

[inputLoop]
    wait
    goto [inputLoop]

[mouseMoved]
    print #main.toolbar, "when mouseMove;"
    overed = checkMap(MouseX,MouseY,toolbar.maps)
        if overed = 1 and currentMouseOver <> 1 then goto [mouseoverNewMapFile]
        if overed = 2 and currentMouseOver <> 2 then goto [mouseoverOpenMapFile]
        if overed = 3 and currentMouseOver <> 3 then goto [mouseoverSaveMapFile]
        if overed = 4 and currentMouseOver <> 4 then goto [mouseoverDeleteItems]
        if overed = 5 and currentMouseOver <> 5 then goto [mouseoverOpenImage]
        if overed = 6 and currentMouseOver <> 6 then goto [mouseoverNewMap]
        if overed = 7 and currentMouseOver <> 7 then goto [mouseoverShowhideBranchlabels]
        if overed = 8 and currentMouseOver <> 8 then goto [mouseoverProduceCode]
        if overed = 0 and currentMouseOver <> 0 then currentMouseOver = 0: print #main.toolbar, "redraw"
    print #main.toolbar, "when mouseMove [mouseMoved];"
    goto [inputLoop]

[mouseoverNewMapFile]
    currentMouseOver = 1
    print #main.toolbar, "when mouseMove;"
        print #main.toolbar, "drawbmp bm21 483 0;"
        print #main.toolbar, "drawbmp bm11 0 0;"
    print #main.toolbar, "when mouseMove [mouseMoved];"
    goto [inputLoop]


[mouseoverOpenMapFile]
    currentMouseOver = 2
    print #main.toolbar, "when mouseMove;"
        print #main.toolbar, "drawbmp bm22 483 0;"
        print #main.toolbar, "drawbmp bm12 50 0;"
    print #main.toolbar, "when mouseMove [mouseMoved];"
    goto [inputLoop]


[mouseoverSaveMapFile]
    currentMouseOver = 3
    print #main.toolbar, "when mouseMove;"
        print #main.toolbar, "drawbmp bm23 483 0;"
        print #main.toolbar, "drawbmp bm13 100 0;"
    print #main.toolbar, "when mouseMove [mouseMoved];"
    goto [inputLoop]


[mouseoverDeleteItems]
    currentMouseOver = 4
    print #main.toolbar, "when mouseMove;"
        print #main.toolbar, "drawbmp bm24 483 0;"
        print #main.toolbar, "drawbmp bm14 150 0;"
    print #main.toolbar, "when mouseMove [mouseMoved];"
    goto [inputLoop]


[mouseoverOpenImage]
    currentMouseOver = 5
    print #main.toolbar, "when mouseMove;"
        print #main.toolbar, "drawbmp bm25 483 0;"
        print #main.toolbar, "drawbmp bm15 200 0;"
    print #main.toolbar, "when mouseMove [mouseMoved];"
    goto [inputLoop]


[mouseoverNewMap]
    currentMouseOver = 6
    print #main.toolbar, "when mouseMove;"
        print #main.toolbar, "drawbmp bm26 483 0;"
        print #main.toolbar, "drawbmp bm16 250 0;"
    print #main.toolbar, "when mouseMove [mouseMoved];"
    goto [inputLoop]


[mouseoverShowhideBranchlabels]
    currentMouseOver = 7
    print #main.toolbar, "when mouseMove;"
        print #main.toolbar, "drawbmp bm27 483 0;"
        print #main.toolbar, "drawbmp bm17 300 0;"
    print #main.toolbar, "when mouseMove [mouseMoved];"
    goto [inputLoop]


[mouseoverProduceCode]
    currentMouseOver = 8
    print #main.toolbar, "when mouseMove;"
        print #main.toolbar, "drawbmp bm28 483 0;"
        print #main.toolbar, "drawbmp bm18 350 0;"
    print #main.toolbar, "when mouseMove [mouseMoved];"
    goto [inputLoop]

[newMapFile]
    for z = 1 to maps
        map(z,1) = 0
        map(z,2) = 0
        map(z,3) = 0
        map(z,4) = 0
        branch$(z,1) = ""
    next z
    for z = 1 to bitmapCount
        a$ = bitmapFile$(z,2)
        unloadbmp a$
        bitmapFile$(z,1) = ""
        bitmapFile$(z,2) = ""
        bitmap(z,1) = 0
        bitmap(z,2) = 0
        bitmap(z,3) = 0
        bitmap(z,4) = 0
    next z
    maps = 0
    bitmapCount = 0
    createMap = 0
    gosub [redrawMaps]
    goto [inputLoop]

[newMap]
    createMap = 1
    goto [inputLoop]

[openMapFile]
    filedialog "Select map file to open:","*.lmp",fileMap$
    if fileMap$ = "" then goto [inputLoop]
    open fileMap$ for input as #save
    for z = 1 to maps
        map(z,1) = 0
        map(z,2) = 0
        map(z,3) = 0
        map(z,4) = 0
        branch$(z,1) = ""
    next z
    for z = 1 to bitmapCount
        a$ = bitmapFile$(z,2)
        unloadbmp a$
        bitmapFile$(z,1) = ""
        bitmapFile$(z,2) = ""
        bitmap(z,1) = 0
        bitmap(z,2) = 0
        bitmap(z,3) = 0
        bitmap(z,4) = 0
    next z
    maps = 0
    bitmapCount = 0
    createMap = 0
    input #save, bitmapCount
    input #save, maps
    for z = 1 to bitmapCount
        input #save, a$:bitmapFile$(z,1)=a$
        input #save, a$:bitmapFile$(z,2)=a$
        input #save, a:bitmap(z,1)=a
        input #save, a:bitmap(z,2)=a
        input #save, a:bitmap(z,3)=a
        input #save, a:bitmap(z,4)=a
        name$ = bitmapFile$(z,2)
        file$ = bitmapFile$(z,1)
        loadbmp name$,file$
    next z
    for z = 1 to maps
        input #save, a$:branch$(z,1)=a$
        input #save, a$:branch$(z,2)=a$
        input #save, a:map(z,1)=a
        input #save, a:map(z,2)=a
        input #save, a:map(z,3)=a
        input #save, a:map(z,4)=a
        input #save, a:map(z,5)=a
    next z
    close #save
    gosub [redrawMaps]
    goto [inputLoop]

[saveMapFile]
    filedialog "Select filename for saving map file:","*.lmp",fileMap$
    if fileMap$ = "" then notice "Not saved!":goto [inputLoop]
    open fileMap$ for output as #save
    print #save, bitmapCount
    print #save, maps
    for z = 1 to bitmapCount
        print #save, bitmapFile$(z,1)
        print #save, bitmapFile$(z,2)
        print #save, bitmap(z,1)
        print #save, bitmap(z,2)
        print #save, bitmap(z,3)
        print #save, bitmap(z,4)
    next z
    for z = 1 to maps
        print #save, branch$(z,1)
        print #save, branch$(z,2)
        print #save, map(z,1)
        print #save, map(z,2)
        print #save, map(z,3)
        print #save, map(z,4)
        print #save, map(z,5)
    next z
    close #save
    notice "Map file saved as"+fileMap$
    goto [inputLoop]

[deleteItems]
    notice "Click on image or map to delete. This cannot be undone!"
    deleteFlag = 1
    goto [inputLoop]

[openImage]
    filename$ = ""
    filedialog "Select Bitmap File:","*.bmp",filename$
    if filename$ = "" then goto [inputLoop]
    gosub [bmpSize]
    bitmapCount = bitmapCount + 1
    bitmapFile$(bitmapCount,1) = filename$
    bitmap(bitmapCount,3) = bmpwidth
    bitmap(bitmapCount,4) = bmpheight
    bitmapFile$(bitmapCount,2) = "bitmap"+str$(bitmapCount)
    name$ = bitmapFile$(bitmapCount,2)
    file$ = bitmapFile$(bitmapCount,1)
    loadbmp name$,file$
    gosub [redrawMaps]
    goto [inputLoop]

[showhideBranchlabels]
    if showhideBranchlabels = 1 then showhideBranchlabels = 0 else showhideBranchlabels = 1
    gosub [redrawMaps]
    goto [inputLoop]


[bmpSize] ' Get the size of a bitmap for a button
    ' Code courtesy Doyle Whisenhunt and Alyce Watson
    open filename$ for input as #pic
    pic$=input$(#pic,29)
    close #pic
    bmpwidth = asc(mid$(pic$,19,1)) + (asc(mid$(pic$,20,1)) * 256)
    bmpheight = asc(mid$(pic$,23,1)) + (asc(mid$(pic$,24,1)) * 256)
    return

[leftButtonClicked]
    clicked = checkMap(MouseX,MouseY,toolbar.maps)
        if clicked = 1 then [newMapFile]
        if clicked = 2 then [openMapFile]
        if clicked = 3 then [saveMapFile]
        if clicked = 4 then [deleteItems]
        if clicked = 5 then [openImage]
        if clicked = 6 then [newMap]
        if clicked = 7 then [showhideBranchlabels]
        if clicked = 8 then [produceCode]
    goto [inputLoop]

[leftButtonClickedMap]
    xNow = MouseX
    yNow = MouseY
    if deleteFlag = 1 then
        deleteFlag = 0
        gosub [checkForMove]
        if moveSelected = 0 then gosub [bitmapCheckForMove]
        if bitmapMoveSelected = 0 and moveSelected = 0 then goto [inputLoop]
        if moveSelected <> 0 then
            for z = moveSelected to maps-1
                map(z,1) = map(z+1,1)
                map(z,2) = map(z+1,2)
                map(z,3) = map(z+1,3)
                map(z,4) = map(z+1,4)
                map(z,5) = map(z+1,5)
                branch$(z,1) = branch$(z+1,1)
                branch$(z,2) = branch$(z+1,2)
            next z
            maps = maps - 1
        end if
        if bitmapMoveSelected <> 0 then
            for z = bitmapMoveSelected to bitmapCount-1
                bitmap(z,1) = bitmap(z+1,1)
                bitmap(z,2) = bitmap(z+1,2)
                bitmap(z,3) = bitmap(z+1,3)
                bitmap(z,4) = bitmap(z+1,4)
                bitmap(z,5) = bitmap(z+1,5)
                bitmapFile$(z,1) = bitmapFile$(z+1,1)
                bitmapFile$(z,2) = bitmapFile$(z+1,2)
            next z
            bitmapCount = bitmapCount - 1
        end if
        gosub [redrawMaps]
        goto [inputLoop]
    end if
    if createMap = 1 then goto [createMapStart]
    gosub [checkForResize]
    if resizeSelected <> 0 then gosub [resizeSelectionStart]
    if resizeSelected = 0 then gosub [checkForMove]
    if moveSelected <> 0 then gosub [moveSelectionStart]
    if moveSelected = 0 and resizeSelected = 0 then gosub [bitmapCheckForMove]
    if bitmapMoveSelected <> 0 then gosub [bitmapMoveSelectionStart]
    goto [inputLoop]

[checkForResize]
    resizeSelected = 0
    for check = 1 to maps
        if  xNow > (map(check,1) + map(check,3) - 3) and_
            xNow < (map(check,1) + map(check,3) + 3) and_
            yNow > (map(check,2) + map(check,4) - 3) and_
            yNow < (map(check,2) + map(check,4) + 3) then_
            resizeSelected = check : check = maps + 1
    next check
    return

[checkForMove]
    moveSelected = 0
    for check = 1 to maps
        if  xNow > map(check,1) and_
            xNow < map(check,1) + map(check,3) and_
            yNow > map(check,2) and_
            yNow < map(check,2) + map(check,4) then_
            moveSelected = check: check = maps + 1
    next check
    return

[bitmapCheckForMove]
    bitmapMoveSelected = 0
    for check = bitmapCount to 1 step -1
        if  xNow > bitmap(check,1) and_
            xNow < bitmap(check,1) + bitmap(check,3) and_
            yNow > bitmap(check,2) and_
            yNow < bitmap(check,2) + bitmap(check,4) then_
            bitmapMoveSelected = check: check = 0
    next check
    return

[createMapStart]
    createMap = 0
    xNow = MouseX
    yNow = MouseY
    oldXNow = xNow
    oldYNow = yNow
    eraseX = xNow
    eraseY = yNow
    print #main.map, "when leftButtonUp [createMapStop]"
    print #main.map, "when leftButtonMove [createMap]"
    goto [inputLoop]

[createMap]
    xNow = MouseX
    yNow = MouseY
    moveX = xNow - oldXNow
    moveY = yNow - oldYNow
    outline$ =  "down; color black; rule xor; place "+str$(oldXNow)+" "+str$(oldYNow)+"; box "+_
                str$(xNow)+" "+str$(yNow)+";"
    print #main.map, "redraw"
    print #main.map, outline$
    eraseX = xNow
    eraseY = yNow
    goto [inputLoop]


[createMapStop]
    maps = maps+1
    print #main.map, "when leftButtonMove ;"
    print #main.map, "when leftButtonUp ;"
    xNow = MouseX
    yNow = MouseY
    moveX = xNow - oldXNow
    moveY = yNow - oldYNow
    map(maps,1)= oldXNow
    map(maps,2)= oldYNow
    map(maps,3)= abs(xNow-oldXNow)
    map(maps,4)= abs(yNow-oldYNow)
    answer$ = branch$(maps,1)
    prompt "Enter branchlabel for this map";answer$
    branch$(maps,1) = answer$
    gosub [redrawMaps]
    goto [inputLoop]

[moveSelectionStart]
    oldXNow = xNow
    oldYNow = yNow
    print #main.map, "when leftButtonMove [moveSelection]"
    print #main.map, "when leftButtonUp [moveSelectionStop]"
    return

[moveSelection]
    xNow = MouseX
    yNow = MouseY
    moveX = xNow - oldXNow
    moveY = yNow - oldYNow
    outline$ =  "down; rule xor; color black; place "+str$(map(moveSelected,1)+moveX)+_
                " "+str$(map(moveSelected,2)+moveY)+"; box "+_
                str$(map(moveSelected,1)+moveX+map(moveSelected,3))+" "+_
                str$(map(moveSelected,2)+moveY+map(moveSelected,4))+";"
    print #main.map, "redraw"
    print #main.map, outline$
    goto [inputLoop]

[moveSelectionStop]
    print #main.map, "when leftButtonMove ;"
    print #main.map, "when leftButtonUp ;"
    xNow = MouseX
    yNow = MouseY
    moveX = xNow - oldXNow
    moveY = yNow - oldYNow
    map(moveSelected,1)= map(moveSelected,1)+moveX
    map(moveSelected,2)= map(moveSelected,2)+moveY
    gosub [redrawMaps]
    moveSelected = 0
    goto [inputLoop]

[resizeSelectionStart]
    oldXNow = xNow
    oldYNow = yNow
    print #main.map, "when leftButtonMove [resizeSelection]"
    print #main.map, "when leftButtonUp [resizeSelectionStop]"
    return

[resizeSelection]
    xNow = MouseX
    yNow = MouseY
    moveX = xNow - oldXNow
    moveY = yNow - oldYNow
    outline$ =  "down; rule xor ; color black;place "+str$(map(resizeSelected,1))+_
                " "+str$(map(resizeSelected,2))+"; box "+_
                str$(map(resizeSelected,1)+moveX+map(resizeSelected,3))+" "+_
                str$(map(resizeSelected,2)+moveY+map(resizeSelected,4))+";"
    print #main.map, "redraw"
    print #main.map, outline$
    goto [inputLoop]

[resizeSelectionStop]
    print #main.map, "when leftButtonMove ;"
    print #main.map, "when leftButtonUp ;"
    xNow = MouseX
    yNow = MouseY
    moveX = xNow - oldXNow
    moveY = yNow - oldYNow
    map(resizeSelected,3)= abs(xNow-map(resizeSelected,1))
    map(resizeSelected,4)= abs(yNow-map(resizeSelected,2))
    resizeSelected = 0
    gosub [redrawMaps]
    goto [inputLoop]

[bitmapMoveSelectionStart]
    oldXNow = xNow
    oldYNow = yNow
    print #main.map, "when leftButtonMove [bitmapMoveSelection]"
    print #main.map, "when leftButtonUp [bitmapMoveSelectionStop]"
    return

[bitmapMoveSelection]
    xNow = MouseX
    yNow = MouseY
    moveX = xNow - oldXNow
    moveY = yNow - oldYNow
    outline$ =  "down; rule xor; color black; place "+str$(bitmap(bitmapMoveSelected,1)+moveX)+_
                " "+str$(bitmap(bitmapMoveSelected,2)+moveY)+"; box "+_
                str$(bitmap(bitmapMoveSelected,1)+moveX+bitmap(bitmapMoveSelected,3))+" "+_
                str$(bitmap(bitmapMoveSelected,2)+moveY+bitmap(bitmapMoveSelected,4))+";"
    print #main.map, "redraw"
    print #main.map, outline$
    goto [inputLoop]

[bitmapMoveSelectionStop]
    print #main.map, "when leftButtonMove ;"
    print #main.map, "when leftButtonUp ;"
    xNow = MouseX
    yNow = MouseY
    moveX = xNow - oldXNow
    moveY = yNow - oldYNow
    bitmap(bitmapMoveSelected,1)= bitmap(bitmapMoveSelected,1)+moveX
    bitmap(bitmapMoveSelected,2)= bitmap(bitmapMoveSelected,2)+moveY
    gosub [redrawMaps]
    bitmapMoveSelected = 0
    goto [inputLoop]

[rightButtonClickedMap]
    goto [inputLoop]

[leftButtonDoubleClickedMap]
    if maps < 1 then goto [inputLoop]
    modifySelected = 0
    xNow = MouseX
    yNow = MouseY
    for check = 1 to maps
        if  xNow > map(check,1) and_
            xNow < map(check,1)+map(check,3) and_
            yNow > map(check,2) and_
            yNow < map(check,2)+map(check,4) then_
            modifySelected = check: check = maps+1
    next check
    if modifySelected = 0 then goto [inputLoop]

    WindowWidth = 416
    WindowHeight = 205

    checkbox #events.mouseover, "On Mouseover goto:", [mouseoverSet], [mouseoverReset], 6, 71, 160, 20
    textbox #events.leftclickBranch, 158, 31, 128, 25
    textbox #events.mouseoverBranch, 158, 66, 128, 25
    button #events.ok, "OK", [acceptEvents], UL, 118, 126, 64, 25
    button #events.cancel, "Cancel", [cancelEvents], UL, 214, 126, 58, 25
    statictext #events.statictext10, "On Click branch to:", 38, 36, 112, 20
    open "Mouse Events" for dialog_nf_modal as #events
    print #events, "font ms_sans_serif 0 16"
    print #events.leftclickBranch, branch$(modifySelected,1)
    print #events.mouseoverBranch, branch$(modifySelected,2)
    if map(modifySelected,5) = 1 then print #events.mouseover, "set"
    goto [inputLoop]

[mouseoverSet]
    map(modifySelected,5) = 1
    goto [inputLoop]

[mouseoverReset]
    map(modifySelected,5) = 0
    goto [inputLoop]

[acceptEvents]
    print #events.leftclickBranch, "!contents?"
    input #events.leftclickBranch, temp$
    branch$(modifySelected,1) = temp$
    if map(modifySelected,5) = 1 then
        print #events.mouseoverBranch, "!contents?"
        input #events.mouseoverBranch, temp$
        branch$(modifySelected,2) = temp$
    else
        branch$(modifySelected,2) = ""
    end if

[cancelEvents]
    close #events
    gosub [redrawMaps]
    goto [inputLoop]

[windowFillColor]
    WindowWidth = 216
    WindowHeight = 155
    combobox #colorWindow.colors, colorType$(), [pickWindowFillColor], 30, 16, 152, 95
    button #colorWindow.ok, "OK", [acceptWindowFillColor], UL, 22, 71, 64, 25
    button #colorWindow.cancel, "Cancel", [cancelWindowFillColor], UL, 118, 71, 64, 25
    open "Choose Window Fill Color:" for dialog_nf_modal as #colorWindow
    print #colorWindow, "font ms_sans_serif 0 16"
    print #colorWindow, "trapclose [cancelWindowFillColor]"
    print #colorWindow.colors, "select ";windowFillColor$
    print #colorWindow.colors, "setfocus"
    goto [inputLoop]

[pickWindowFillColor]
    print #colorWindow.colors, "selection? fillColorTemp$"
    goto [inputLoop]

[acceptWindowFillColor]
    windowFillColor$ = fillColorTemp$
    if fillColorTemp$ = "" or fillColorTemp$ = "none" then windowFillColor$ = ""

[cancelWindowFillColor]
    fillColorTemp$ = ""
    close #colorWindow
    gosub [redrawMaps]
    goto [inputLoop]

[redrawMaps]
    print #main.map, "cls"
    if windowFillColor$ <> "" then print #main.map, "fill ";windowFillColor$
    if bitmapFile$(1,1)<>"" then
        for z = 1 to bitmapCount
            drawit$ = "drawbmp "+bitmapFile$(z,2)+" "+str$(bitmap(z,1))+" "+str$(bitmap(z,2))+";flush"
            print #main.map, drawit$
        next z
    end if
    if maps < 1 then return
    for drawing = 1 to maps

        label$ =  "down; rule over; color black;place "+str$(map(drawing,1)+4)+_
                    " "+str$(map(drawing,2)+12)+";\"+branch$(drawing,1)
        outline$ =  "down; rule over; color black;place "+str$(map(drawing,1))+_
                    " "+str$(map(drawing,2))+"; box "+_
                    str$(map(drawing,1)+map(drawing,3))+" "+_
                    str$(map(drawing,2)+map(drawing,4))+";"
        inline$ =  "down; rule over; color white;place "+str$(map(drawing,1)+1)+_
                    " "+str$(map(drawing,2)+1)+"; box "+_
                    str$(map(drawing,1)+map(drawing,3)-1)+" "+_
                    str$(map(drawing,2)+map(drawing,4)-1)+";"
        handleout$ = "size 2;down; rule over; color black;place "+str$(map(drawing,1)+map(drawing,3)-3)+" "+_
                  str$(map(drawing,2)+map(drawing,4)-3)+"; boxfilled "+_
                  str$(map(drawing,1)+map(drawing,3)+3)+" "+_
                  str$(map(drawing,2)+map(drawing,4)+3)+";size 1;"
        handlein$ = "size 2;down; rule over; color white;place "+str$(map(drawing,1)+map(drawing,3)-2)+" "+_
                  str$(map(drawing,2)+map(drawing,4)-2)+"; boxfilled "+_
                  str$(map(drawing,1)+map(drawing,3)+2)+" "+_
                  str$(map(drawing,2)+map(drawing,4)+2)+";size 1;"

        print #main.map, outline$
        print #main.map, inline$
        print #main.map, handleout$
        print #main.map, handlein$
        if showhideBranchlabels = 1 then print #main.map, label$

    next drawing
    print #main.map, "flush";
    return

[produceCode]
    'Include a window the same size as the bitmap
    'Include maps selection routine
    'Include
    if maps < 1 then goto [inputLoop]
    open "Output code" for text as #code
    mouseOverActive = 0
    print #code, "!trapclose [closeCode]"
        print #code, "    nomainwin"
        print #code, ""
        print #code, "    dim clickable(";maps;"100,4)"
        print #code, ""
    for z = 1 to bitmapCount
        print #code, "    loadbmp ";chr$(34);"bm";z;chr$(34);",";chr$(34);bitmapFile$(z,1);chr$(34)
    next z
        print #code, ""
        print #code, "    WindowWidth = 640"
        print #code, "    WindowHeight = 480"
        print #code, "    UpperLeftX = 1"
        print #code, "    UpperLeftY = 1"
        print #code, "    graphicbox #main.gb, 0, 0, 640, 460"
        print #code, ""
        print #code, "    open ";chr$(34);"Window";chr$(34);" for window as #main"
        print #code, ""
        print #code, "    print #main.gb, ";chr$(34);"fill buttonface";chr$(34)
        print #code, "    print #main.gb, ";chr$(34);"flush;";chr$(34)
        print #code, ""
        print #code, "    rem Set up clickable map coordinates"
        print #code, "    maps = ";maps
        print #code, "    print #main, ";chr$(34);"trapclose [quit]";chr$(34)
        print #code, ""
    for z = 1 to maps
        print #code, "    ";chr$(39);" Coordinates for area that branches to ";branch$(z,1)
        print #code, "    clickable(";z;",1) = ";map(z,1);": rem X location"
        print #code, "    clickable(";z;",2) = ";map(z,2);": rem Y location"
        print #code, "    clickable(";z;",3) = ";map(z,3);": rem Width"
        print #code, "    clickable(";z;",4) = ";map(z,4);": rem Height"
    next z
        print #code, ""
    for z = 1 to bitmapCount
        print #code, "    print #main.gb, ";chr$(34);"drawbmp bm";z;" ";str$(bitmap(z,1));" ";str$(bitmap(z,2));";";chr$(34)
    next z
        print #code, "    print #main.gb, ";chr$(34);"flush;";chr$(34)
        print #code, "    print #main.gb, ";chr$(34);"when leftButtonDown [leftButtonClicked]";chr$(34)
        mouseOverActive = 0
        for z = 1 to maps: if branch$(z,2)<>"" then mouseOverActive = 1:next z
        if mouseOverActive = 1 then
            print #code, "    print #main.gb, ";chr$(34);"when mouseMove [mouseMoved]";chr$(34)
        end if
        print #code, ""
        print #code, "[inputLoop]"
        print #code, "    wait"
        print #code, ""
        print #code, "[leftButtonClicked]"
        print #code, "    clicked = checkMap(MouseX,MouseY,maps)"
        for z = 1 to maps
            print #code, "        if clicked = ";z;" then ";branch$(z,1)
        next z

            print #code, "    goto [inputLoop]"

        if mouseOverActive = 1 then
            print #code, "[mouseMoved]"
            print #code, "    print #main.gb, ";chr$(34);"when mouseMove;";chr$(34)
            print #code, "    overed = checkMap(MouseX,MouseY,maps)"
            for z = 1 to maps
                if branch$(z,2) <> "" then
                    print #code, "        if overed = ";z;" and currentMouseOver <> ";z;" then goto ";branch$(z,2)
                end if
            next z
            print #code, "        if overed = 0 and currentMouseOver <> 0 then currentMouseOver = 0: print #main.gb, ";chr$(34);"redraw";chr$(34)
            print #code, "    print #main.gb, ";chr$(34);"when mouseMove [mouseMoved];";chr$(34)
            print #code, "    goto [inputLoop]"
        end if

        for z = 1 to maps
            for z2 = 1 to z-1
                if branch$(z,1) = branch$(z2,1) then [skipBranch]
            next z2
            print #code, ""
            print #code, branch$(z,1)
            print #code, "    ";chr$(39);" Whatever happens for clicking on area ";z
            print #code, "    notice ";chr$(34);branch$(z,1);" clicked";chr$(34)
            print #code, "    goto [inputLoop]"
        [skipBranch]
        next z

        if mouseOverActive = 1 then
        for z = 1 to maps
            if branch$(z,2) <> "" then
                for z2 = 1 to z-1
                    if branch$(z,2) = branch$(z2,2) then goto [skipBranch2]
                next z2
                print #code, ""
                print #code, branch$(z,2)
                print #code, "    currentMouseOver = ";z
                print #code, "    print #main.gb, ";chr$(34);"when mouseMove;";chr$(34)
                print #code, "        ";chr$(39);" Whatever happens when mouse moves over area ";z
                print #code, "    print #main.gb, ";chr$(34);"when mouseMove [mouseMoved];";chr$(34)
                print #code, "    goto [inputLoop]"
            [skipBranch2]
            end if
            print #code, ""
        next z
        end if
        print #code, ""
        print #code, "[quit]"
        print #code, "    close #main"
        print #code, "    end"
        print #code, ""
        print #code, "function checkMap(MouseX,MouseY,maps)"
        print #code, "   for check = 1 to maps"
        print #code, "     if MouseX > clickable(check,1) and_"
        print #code, "       MouseX < clickable(check,1)+clickable(check,3) and_"
        print #code, "       MouseY > clickable(check,2) and_"
        print #code, "       MouseY < clickable(check,2)+clickable(check,4) then_"
        print #code, "       checkMap = check:check = maps + 1"
        print #code, "   next check"
        print #code,"end function"

    goto [inputLoop]

[aboutMapper]
    xLoc = DisplayWidth/2 - 150
    yLoc = DisplayHeight/2 - 100
    WindowWidth = 300
    WindowHeight = 200
    UpperLeftX = xLoc
    UpperLeftY = yLoc
    BackgroundColor$ = "yellow"
    ForegroundColor$ = "black"
    statictext #about.statictext2, "Mapper 2.0", 62, 26, 80, 20
    statictext #about.statictext3, "Created by David Drake", 62, 46, 176, 20
    statictext #about.statictext4, "June 2001", 62, 61, 72, 20
    statictext #about.statictext5, "drake@apexmail.com", 62, 76, 144, 20
    statictext #about.statictext6, "This stuff is open source, ya know!", 62, 106, 224, 20
    button #about.button7, "OK", [closeAbout], UL, 110, 136, 72, 25
    open "About Mapper 2.0..." for dialog_nf_modal as #about
    print #about, "font arial 0 16"
    goto [inputLoop]

[closeAbout]
    close #about
    goto [inputLoop]

[closeCode]
    close #code
    goto [inputLoop]

[quit]
    close #main
    unloadbmp "bm1"
    unloadbmp "bm2"
    unloadbmp "bm3"
    unloadbmp "bm4"
    unloadbmp "bm5"
    unloadbmp "bm6"
    unloadbmp "bm7"
    unloadbmp "bm8"
    unloadbmp "bm11"
    unloadbmp "bm12"
    unloadbmp "bm13"
    unloadbmp "bm14"
    unloadbmp "bm15"
    unloadbmp "bm16"
    unloadbmp "bm17"
    unloadbmp "bm18"
    unloadbmp "bm21"
    unloadbmp "bm22"
    unloadbmp "bm23"
    unloadbmp "bm24"
    unloadbmp "bm25"
    unloadbmp "bm26"
    unloadbmp "bm27"
    unloadbmp "bm28"
    end

function checkMap(MouseX,MouseY,maps)
    for check = 1 to maps
        if MouseX > clickable(check,1) and_
           MouseX < clickable(check,1)+clickable(check,3) and_
           MouseY > clickable(check,2) and_
           MouseY < clickable(check,2)+clickable(check,4) then_
           checkMap = check:check = maps+1
    next check
end function

